/*
 * Copyright 2010 James Pether Sörling
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *	$Id: WorldBankApi.java 4085 2010-08-01 05:20:24Z pether $
 *  $HeadURL: https://cia.svn.sourceforge.net/svnroot/cia/tags/service.external.worldbank-1.0.0-beta-1/src/main/java/com/hack23/cia/service/external/worldbank/api/WorldBankApi.java $
*/
package com.hack23.cia.service.external.worldbank.api;

import java.util.List;

import com.hack23.cia.model.external.worldbank.countries.impl.CountryElement;
import com.hack23.cia.model.external.worldbank.data.impl.Data;
import com.hack23.cia.model.external.worldbank.indicators.impl.IndicatorElement;



/**
 * The Interface WorldBankApi.
 */
public interface WorldBankApi {

	/**
	 * Gets the countries.
	 * 
	 * @return the countries
	 * @throws Exception
	 *             the exception
	 */
	List<CountryElement> getCountries() throws Exception;

	/**
	 * Gets the data.
	 * 
	 * @param countryCode
	 *            the country code
	 * @param indicatorId
	 *            the indicator id
	 * @return the data
	 * @throws Exception
	 *             the exception
	 */
	List<Data> getData(String countryCode, String indicatorId) throws Exception;

	/**
	 * Gets the indicators.
	 * 
	 * @return the indicators
	 * @throws Exception
	 *             the exception
	 */
	List<IndicatorElement> getIndicators() throws Exception;

}
